<?php

namespace App\Plugins\BinanceBundle;

use App\CoinAdapters\Abstracts\AbstractBinanceTokenAdapter;
use Brick\Math\BigDecimal;

class FEGAdapter extends AbstractBinanceTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'FEGtoken (BEP)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'feg-bep';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 9;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 9;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'FEG';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#FDAF32';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0xacFC95585D80Ab62f67A14C566C1b7a49Fe91167';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x7BD76fdD52f5a11f3aaa955760F17fEe123776ec';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/binance-bundle/feg.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return "fegtoken";
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(100000000000000000);
    }
}