<?php

namespace App\Plugins\BinanceBundle;

use App\CoinAdapters\Abstracts\AbstractBinanceTokenAdapter;
use Brick\Math\BigDecimal;

class NFTPAdapter extends AbstractBinanceTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Binance-Peg APENFT Token (BEP)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'nft-bep';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '1000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 6;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 8;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'NFT';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#5560FF';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x1fC9004eC7E5722891f5f38baE7678efCB11d34D';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xF7437bAb2F484cD3dCd844DFfd9CBe87F9E2A699';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/binance-bundle/ape.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return "apenft";
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(100000000000000);
    }
}