<?php

namespace App\Plugins\BinanceBundle;

use App\Abstracts\CoinServiceProvider;

class PluginServiceProvider extends CoinServiceProvider
{
    /**
     * @inheritDoc
     */
    protected string $name = 'binance-bundle';

    /**
     * @inheritDoc
     */
    protected array $adapters = [
        MATICAdapter::class,
        ETHAdapter::class,
        USDTAdapter::class,
        USDCAdapter::class,
        XRPAdapter::class,
        ADAAdapter::class,
        DOGEAdapter::class,
        DOTAdapter::class,
        LTCAdapter::class,
        SHIBAdapter::class,
        AVAXAdapter::class,
        DAIAdapter::class,
        CAKEAdapter::class,
        SOULAdapter::class,
        OMAdapter::class,
        UNIAdapter::class,
        ATOMAdapter::class,
        LINKAdapter::class,
        ETCAdapter::class,
        BCHAdapter::class,
        BTTPAdapter::class,
        NEARAdapter::class,
        AXSAdapter::class,
        FTMAdapter::class,
        BTCBAdapter::class,
        EOSAdapter::class,
        FLOWAdapter::class,
        FRAXAdapter::class,
        EGLDAdapter::class,
        XTZAdapter::class,
        USDPAdapter::class,
        TUSDAdapter::class,
        FXSAdapter::class,
        ZECAdapter::class,
        XECAdapter::class,
        SNXAdapter::class,
        TWTAdapter::class,
        MKRAdapter::class,
        PAXGAdapter::class,
        ZILAdapter::class,
        INCHAdapter::class,
        GALAAdapter::class,
        COMPAdapter::class,
        BATAdapter::class,
        IOTXAdapter::class,
        ANKRAdapter::class,
        YFIAdapter::class,
        JSTAdapter::class,
        USTCAdapter::class,
        FETAdapter::class,
        ONTAdapter::class,
        VBTCAdapter::class,
        ANYAdapter::class,
        COSAdapter::class,
        SFPAdapter::class,
        SXPAdapter::class,
        NESTAdapter::class,
        ILVAdapter::class,
        NFTAdapter::class,
        NFTPAdapter::class,
        SETAdapter::class,
        KNCAdapter::class,
        SLPAdapter::class,
        BANDAdapter::class,
        COTIAdapter::class,
        ALICEAdapter::class,
        CEEKAdapter::class,
        ALPHAAdapter::class,
        DEXEAdapter::class,
        CELRAdapter::class,
        CTSIAdapter::class,
        ELFAdapter::class,
        MBOXAdapter::class,
        MDXAdapter::class,
        WRXAdapter::class,
        ORBSAdapter::class,
        ACHAdapter::class,
        XVSAdapter::class,
        RACAAdapter::class,
        TLMAdapter::class,
        VLXAdapter::class,
        PHAAdapter::class,
        BNTAdapter::class,
        REEFAdapter::class,
        NRVAdapter::class,
        CTKAdapter::class,
        VAIAdapter::class,
        DODOAdapter::class,
        YFIIAdapter::class,
        ATAAdapter::class,
        AMPLAdapter::class,
        POLSAdapter::class,
        TLOSAdapter::class,
        ALPACAAdapter::class,
        MTRGAdapter::class,
        HEROAdapter::class,
        LITAdapter::class,
        SAITOAdapter::class,
        LTOAdapter::class,
        BAKEAdapter::class,
        KMDAdapter::class,
        BIFIAdapter::class,
        AVAAdapter::class,
        LINAAdapter::class,
        FINEAdapter::class,
        RAMPAdapter::class,
        FREEAdapter::class,
        DIAAdapter::class,
        FEGAdapter::class,
        CLVAdapter::class,
        XPRAdapter::class,
        AIOZAdapter::class,
        BELAdapter::class,
        EPSAdapter::class,
        ADXAdapter::class,
        TKOAdapter::class,
        FARMAdapter::class,
        CREAMAdapter::class,
        CHESSAdapter::class,
        UFTAdapter::class,
        DFAdapter::class,
        FRONTAdapter::class,
        MDTAdapter::class,
        SDAOAdapter::class,
        MATHAdapter::class
    ];

    /**
     * @inheritDoc
     */
    protected function resourcePath(): string
    {
        return __DIR__ . '/resources';
    }
}