<?php

namespace App\Plugins\BinanceBundle;

use App\CoinAdapters\Abstracts\AbstractBinanceTokenAdapter;
use Brick\Math\BigDecimal;

class SOULAdapter extends AbstractBinanceTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Phantasma Stake (BEP)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'soul-bep';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '100000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 2;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'SOUL';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#6CA2CB';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x298Eff8af1ecEbbB2c034eaA3b9a5d0Cc56c59CD';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0x73AB7882c9f15b5606d4601810A058B390C26Dc6';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/binance-bundle/soul.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return "phantasma";
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(100000000);
    }
}