<?php

namespace App\Plugins\BinanceBundle;

use App\CoinAdapters\Abstracts\AbstractBinanceTokenAdapter;
use Brick\Math\BigDecimal;

class TLMAdapter extends AbstractBinanceTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Alien Worlds Trilium (BEP)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'tlm-bep';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '10000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 4;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 3;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'TLM';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#7BFFA3';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x2222227E22102Fe3322098e4CBfE18cFebD57c95';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xd9E90BfD1B1Ae6221856804ADD4ff1b569363bD1';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/binance-bundle/tlm.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return "alien-worlds";
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(1000000000);
    }
}