<?php

namespace App\Plugins\BinanceBundle;

use App\CoinAdapters\Abstracts\AbstractBinanceTokenAdapter;
use Brick\Math\BigDecimal;

class VBTCAdapter extends AbstractBinanceTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Venus BTC (BEP)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'vbtc-bep';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '100000000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 8;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 2;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'VBTC';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#FFB320';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x882C173bC7Ff3b7786CA16dfeD3DFFfb9Ee7847B';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xb252d6F686A90DA4c43fC60d693C8DB7ff89143C';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/binance-bundle/vbtc.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return "venus-btc";
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(0.0001);
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(10000000);
    }
}