<?php

namespace App\Plugins\BinanceBundle;

use App\CoinAdapters\Abstracts\AbstractBinanceTokenAdapter;
use Brick\Math\BigDecimal;

class XPRAdapter extends AbstractBinanceTokenAdapter
{
    /**
     * {@inheritDoc}
     */
    protected string $name = 'Proton (BEP)';

    /**
     * {@inheritDoc}
     */
    protected string $identifier = 'xpr-bep';

    /**
     * {@inheritDoc}
     */
    protected string $baseUnit = '10000';

    /**
     * {@inheritDoc}
     */
    protected int $precision = 4;

    /**
     * {@inheritDoc}
     */
    protected int $currencyPrecision = 4;

    /**
     * {@inheritDoc}
     */
    protected string $symbol = 'XPR';

    /**
     * {@inheritDoc}
     */
    protected bool $symbolFirst = true;

    /**
     * {@inheritDoc}
     */
    protected string $color = '#6552A3';

    /**
     * {@inheritDoc}
     */
    protected string $contract = '0x5de3939b2F811A61d830E6F52d13B066881412ab';

    /**
     * {@inheritDoc}
     */
    protected string $testContract = '0xFab8bc9a4b4A24f3f2663eFA34BcACDdff4132E7';

    /**
     * {@inheritDoc}
     */
    public function getSvgIcon(): string
    {
        return asset('coin/binance-bundle/xpr.svg');
    }

    /**
     * {@inheritDoc}
     */
    public function marketId(): string
    {
        return "proton";
    }

    /**
     * {@inheritDoc}
     */
    public function getMinimumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit());
    }

    /**
     * {@inheritDoc}
     */
    public function getMaximumTransferable(): string
    {
        return (string) BigDecimal::of($this->getBaseUnit())->multipliedBy(10000000000);
    }
}